#!/usr/bin/env python
# encoding: utf-8
import os
import sys
import json
import pprint
import numpy
import networkx
import matplotlib.pylab as plt

def perform(graph):
  ''' Takes a networkx.Graph, calculates certain component related metrics and
  returns a 3-tuple containing the graph's number of components, the size of
  the largest component and the component distribution. '''

  number_of_components, largest_component_size, component_distribution = 0, 0, []

  # TODO Student: Calculate the graph's number of components
  # TODO Student: Calculate the size of the graph's largest component.
  # TODO Student: Calculate the graph's component distribution (fraction of
  #               nodes in percent belonging to a component of size n).


  return (number_of_components, largest_component_size, component_distribution)

def plot(results):
  ''' Plots the given results returned from 'perform' and stores the resulting
      file in the submission folder. '''

  _, size_of_largest_component, component_distribution = results

  plt.bar(range(1, size_of_largest_component + 1), component_distribution)
  plt.ylabel("Fraction of Nodes %")
  plt.xlabel("Size of Component")
  plt.title("Component Distribution")
  plt.savefig("components.png")

if __name__ == u'__main__':
  graph = networkx.read_gml(u'graph-a.gml.gz')
  results = perform(graph)
  plot(results)

  pprint.pprint(results)
