#!/usr/bin/env python
# encoding: utf-8
import os
import sys
import json
import pprint
import numpy
import networkx
import matplotlib.pylab as plt

def perform(graph):
  ''' Takes a networkx.Graph, calculates certain degree related metrics and
  returns a 3-tuple containing the graph's highest node degree found in the
  graph, the average degree of a node in the graph and the degree distribution
  itself. '''

  maximum_degree, average_degree, degree_distribution = 0, 0.0, []

  # TODO Student: Calculate the maximum degree.
  # TODO Student: Calculate the average degree of a node.
  # TODO Student: Calculate the graph's degree distribution.

  degrees = []


  if len(degrees) > 0 and maximum_degree > 0:
    plot(degrees, maximum_degree)

  return (maximum_degree, average_degree, degree_distribution)

def plot(degrees, maximum_degree):
  ''' Plots the given results returned from 'perform' and stores the resulting
      file in the submission folder. '''

  plt.title("Degree Distribution")
  plt.hist(degrees, bins=maximum_degree, normed=True)
  plt.xlabel("Degree $k$")
  plt.ylabel("$p(k)$")
  plt.savefig("degree.png")

if __name__ == u'__main__':
  graph = networkx.read_gml(u'graph-a.gml.gz')
  results = perform(graph)

  pprint.pprint(results)

