#!/usr/bin/env python
# encoding: utf-8
import os
import sys
import json
import pprint
import numpy
import networkx
import matplotlib.pylab as plt

def perform(graph):
  ''' Takes a networkx.Graph, calculates certain distance related metrics and
  returns a 3-tuple containing the graph's diameter, average vertex distance
  and (normalized) distance distribution. '''

  diameter, average_distance, distance_distribution = 0, 0.0, []

  # TODO Student: Calculate the graph's diameter.
  # TODO Student: Calculate the graph's average distance between nodes.
  # TODO Student: Calculate the graph's distances.
  # TODO Student: Calculate the graph's distance distribution.

  distances = []


  if len(distances) > 0 and diameter > 0:
    plot(distances, diameter)

  return (diameter, average_distance, distance_distribution)

def plot(distances, diameter):
  ''' Plots the given results returned from 'perform' and stores the resulting
      file in the submission folder. '''

  plt.title("Distance Distribution")
  plt.hist(distances, bins=diameter, normed=True, align='right')
  plt.xlabel("Distance $d$")
  plt.ylabel("$p(d)$")
  plt.savefig("distance.png")

if __name__ == u'__main__':
  graph = networkx.read_gml(u'graph-b.gml.gz')
  results = perform(graph)

  pprint.pprint(results)

